// RegistryInf.cpp: implementation of the RegistryInf class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include "resource.h"
#include "RegistryInf.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RegistryInf::RegistryInf()
{

}

RegistryInf::~RegistryInf()
{

}

BSTR RegistryInf::GetKeyValue(LPCTSTR KeyPath, LPCTSTR KeyName)
{
	HKEY	hkey;
	DWORD	dwDisposition;
	DWORD	dwType;
	DWORD	dwSize;

	TCHAR sKeyValue[512];
	_tcscpy(sKeyValue, TEXT(""));


	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, KeyPath, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition)==ERROR_SUCCESS)
	{
		dwType = REG_SZ;
		dwSize = sizeof(sKeyValue);
		if(RegQueryValueEx(hkey, KeyName, 0, &dwType, (PBYTE)&sKeyValue, &dwSize)!=ERROR_SUCCESS)
		{ 
			RegCloseKey(hkey);
			return	TEXT("\0");
		}
		RegCloseKey(hkey);
	}
	
	return CComBSTR(sKeyValue).m_str;
}


HRESULT RegistryInf::PutKeyValue(LPCTSTR KeyPath, LPCTSTR KeyName, LPCTSTR KeyValue)
{
	HKEY	hkey;
	DWORD	dwDisposition;
	DWORD	dwType;
	DWORD	dwSize;
	HRESULT hr = S_OK;
	TCHAR m_sKeyValue[512];
	_tcscpy(m_sKeyValue, KeyValue);
	

	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, KeyPath, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition)==ERROR_SUCCESS)
	{
		dwType = REG_SZ;
		dwSize = (_tcslen(KeyValue) + 1) * sizeof(TCHAR);
		if(RegSetValueEx(hkey, KeyName, 0, dwType, (PBYTE)&m_sKeyValue, dwSize)!=ERROR_SUCCESS)
			hr = E_FAIL;
		RegCloseKey(hkey);
	}
	else
		hr = E_FAIL;
		
	return hr;
}

_bstr_t RegistryInf::GetKeyValueEx(LPCTSTR KeyPath, LPCTSTR KeyName)
{
	HKEY	hkey;
	DWORD	dwDisposition;
	DWORD	dwType;
	DWORD	dwSize;

	TCHAR sKeyValue[512];
	_tcscpy(sKeyValue, TEXT(""));
	
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE, KeyPath, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition)==ERROR_SUCCESS)
	{
		dwType = REG_SZ;
		dwSize = sizeof(sKeyValue);
		if(RegQueryValueEx(hkey, KeyName, 0, &dwType, (PBYTE)&sKeyValue, &dwSize)!=ERROR_SUCCESS)
			_tcscpy(sKeyValue, TEXT(""));
		RegCloseKey(hkey);
	}
	
	return _bstr_t(sKeyValue).copy();
}
