// stdafx.h : include file for standard system include files,
//      or project specific include files that are used frequently,
//      but are changed infrequently

#if !defined(AFX_STDAFX_H__10DE3448_1BD3_4C8A_91E6_DEDFDF47864B__INCLUDED_)
#define AFX_STDAFX_H__10DE3448_1BD3_4C8A_91E6_DEDFDF47864B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif

#define UNICODE


#define _ATL_APARTMENT_THREADED

#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override
//something, but do not change the name of _Module

#include	<comdef.h>
#import		"..\ReplicationServer\ReplicationServer.tlb" no_namespace named_guids raw_interfaces_only
#include	"..\Include\EnBSTR.h"
#include	"..\Include\RegistryInf.h"

#include <windows.h>
#include <winbase.h>
#include <ntsecapi.h>
#include <lm.h>					// for NetXxx API
#include <time.h>
#include <stdio.h>

#define RTN_OK 0
#define RTN_USAGE 1
#define RTN_ERROR 13

class CServiceModule : public CComModule
{
public:
	HRESULT RegisterServer(BOOL bRegTypeLib, BOOL bService);
	HRESULT UnregisterServer();
	void Init(_ATL_OBJMAP_ENTRY* p, HINSTANCE h, UINT nServiceNameID, const GUID* plibid = NULL);
    void Start();
	void ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv);
    void Handler(DWORD dwOpcode);
    void Run();
    BOOL IsInstalled();
    BOOL Install();
    BOOL Uninstall();
	LONG Unlock();
	void LogEvent(LPCTSTR pszFormat, ...);
    void SetServiceStatus(DWORD dwState);
    void SetupAsLocalServer();

	
	CServiceModule();

//Implementation
private:
	static void WINAPI _ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv);
    static void WINAPI _Handler(DWORD dwOpcode);

	void		ReadSettingsRegs(LPTSTR &szAccountName, LPTSTR &szAccountPassword);
	void		WriteSettingsRegsAccount(LPTSTR szAccountName, LPTSTR AccountPassword);
	bool		ManageAccount();
// data members
public:
    TCHAR				m_szServiceName[256];
    SERVICE_STATUS_HANDLE m_hServiceStatus;
    SERVICE_STATUS		m_status;
	DWORD				dwThreadID;
	BOOL				m_bService;

	TCHAR				m_szAccountName[256];
	TCHAR				m_szAccountPassword[256];
};

extern CServiceModule _Module;
#include <atlcom.h>

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__10DE3448_1BD3_4C8A_91E6_DEDFDF47864B__INCLUDED)
